# digitalSTROM Server - dSS

Please visit http://redmine.digitalstrom.org/projects/dss/wiki/

Also see the INSTALL document for information on how to build the dSS.

## Autoconf build

```sh
mkdir -p build-autoconf
cd build-autoconf && \
    ../configure --prefix=$PREFIX --with-search=$PREFIX
make -j $(nproc)
make install
``


## Meson build

1. Copy `config.h.in` from autoconf build to `src/config.h.in`


```sh
    cp build-autoconf/config.h build-meson/
    cp build-autoconf/build/build_info.h build-meson/
```

2.
```sh
. ../env.sh (like in autoconf)
meson build-meson -Dsearch=$PREFIX
ninja -C build-meson
```

`-Dsearch=$PREFIX` provides path to dsm-api library (missing integration with pkgconfig).


## Meson build with clang, asan, werrror

```sh
time \
    CC=clang \
    CXX=clang++ \
    LDFLAGS="-fuse-ld=lld" \
    meson build-meson \
    --prefix=$PREFIX \
    -Dsearch=$PREFIX \
    -Dwerror=true \
    -Db_sanitize=address \
    -Db_lundef=false
time ninja -C build-meson
```
