/*
    Copyright (c) 2021 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/
#include "remote-connectivity.h"
#include <ds/asio/test.h>
#include <ds/catch/catch.h>
#include <ds/log.h>

static const char* TAGS = "[remoteConnectivity][ds-apartment]";

namespace {

TEST_CASE("remoteConnectivity", TAGS) {
  SECTION("checkCustomizedPassword") {
    auto system = ds::makeSystem({.sysconfdir = "./", .datadir = "./"});
    DS_DEFER(system->remove(ds::str(system->dirs().sysconfdir, "lighttpd.user")));
    system->writeToFile(ds::str(system->dirs().sysconfdir, "lighttpd.user"), R"(dssadmin:dSS11:79f2e01bf54e8a0626f04b139a1decc2)");
    CHECK(dsApartment::hasCustomizedPassword(*system) == false);
    system->writeToFile(ds::str(system->dirs().sysconfdir, "lighttpd.user"), R"(dssadmin:dSS11:3b9b3a584ef3f1fb3ebe9832c4c5e029)");
    CHECK(dsApartment::hasCustomizedPassword(*system) == true);
  }
}

} // namespace
