/*
    Copyright (c) 2018  digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

*/
#pragma once

#include <trompeloeil.hpp>

#include "event.h"

namespace dsApi {

struct EventHubMock : public trompeloeil::mock_interface<EventHub> {
  IMPLEMENT_MOCK1(emitEvent);
  IMPLEMENT_MOCK2(subscribe);

  // Every evenSink is subscribed to this signal with stream of events
  ds::Signal<ds::Box<dsApi::Event>> m_event{};

private:
  ds::Slots<ds::Box<dsApi::Event>>& event() override { return m_event; };
};

} // namespace dsApi
