#pragma once

#include <ds-model/apartment-api-fwd.h>
#include <ds-model/meterings-fwd.h>

#include "model/apartment.h"

namespace dss {

struct DecodedMeteringId {
  dsModel::MeteringOrigin origin{};
  dsModel::MeteringType meteringType{};
};

DecodedMeteringId decodeId(const dsModel::MeteringId&);
dsModel::MeteringId encodeId(const dsModel::MeteringOrigin&, dsModel::MeteringType);

std::unique_ptr<dsModel::MeteringsApi> makeDsMeterings(ds::asio::ResourceBase& parent, Apartment& apartment,
                                                       dsApi::EventHub& eventHub);

} // namespace dss

DS_REFLECT_STRUCT((dss), DecodedMeteringId, (origin)(meteringType));
