// Generated file.  DO NOT EDIT!
// source: devices.yaml

// clang-format off

#pragma once


/// Devices
///
/// DsDevices, submodules, function blocks, outputs, sensors, etc

#include "devices-fwd.h"
#include <ds/enum.h>
#include <ds/clock.h>

#include "common-fwd.h"
#include "groups-fwd.h"
#include "installation-fwd.h"
#include "scenarios-fwd.h"
#include "common.h"

#include <ds/json.h>


/// Direction of heading for e.g. window or door
///
/// Example: north
DS_REFLECTED_ENUM((dsModel), IntercardinalDirection,
    (none)
    (north)
    (west)
    (south)
    (east)
    (northWest)
    (southWest)
    (northEast)
    (southEast)
);

DS_REFLECTED_ENUM((dsModel), OutputType,
    (none)
    (lightBrightness)
    (lightHue)
    (lightSaturation)
    (lightTemperature)
    (lightCieX)
    (lightCieY)
    (shadePositionOutside)
    (shadePositionIndoor)
    (shadeOpeningAngleOutside)
    (shadeOpeningAngleIndoor)
    (shadeTransparency)
    (airFlowIntensity)
    (airFlowDirection)
    (airFlapOpeningAngle)
    (ventilationLouverPosition)
    (heatingPower)
    (coolingCapacity)
    (audioVolume)
    (powerState)
    (ventilationSwingMode)
    (ventilationAutoIntensity)
    (waterTemperature)
    (waterFlowRate)
    (powerLevel)
    (videoStation)
    (videoInputSource)
);

DS_REFLECTED_ENUM((dsModel), OutputFunction,
    (none)
    (switched)
    (gradual)
    (positional)
    (internal)
);

DS_REFLECTED_ENUM((dsModel), OutputMode,
    (none)
    (disabled)
    (switched)
    (gradual)
    (positional)
    (internal)
);


/// Example: ok
DS_REFLECTED_ENUM((dsModel), OutputStatusStatus,
    (none)
    (ok)
    (moving)
    (dimming)
    (overload)
    (blocked)
    (error)
    (standby)
);

DS_REFLECTED_ENUM((dsModel), ButtonType,
    (none)
    (device)
    (area1)
    (area2)
    (area3)
    (area4)
    (zone)
    (zone1)
    (zone2)
    (zone3)
    (zone4)
    (zonex1)
    (zonex2)
    (zonex3)
    (zonex4)
    (application)
    (group)
    (appmode)
);

DS_REFLECTED_ENUM((dsModel), ButtonMode,
    (none)
    (disabled)
    (button1way)
    (button2way)
);

DS_REFLECTED_ENUM((dsModel), MeasurementType,
    (none)
    (temperature)
    (brightness)
    (humidity)
    (carbonDioxide)
    (temperatureSetpoint)
    (temperatureControlValue)
    (energy)
    (energyCounter)
    (energyProduced)
    (energyProducedCounter)
);

DS_REFLECTED_ENUM((dsModel), MeasurementUsage,
    (none)
    (zone)
    (outdoor)
    (settings)
    (device)
    (deviceLastRun)
    (deviceAverage)
);


/// Example: ok
DS_REFLECTED_ENUM((dsModel), SensorStatusStatus,
    (none)
    (ok)
    (error)
);


/// Classification of product type
///
/// Example: rollerShutter
DS_REFLECTED_ENUM((dsModel), ShadeType,
    (none)
    (rollerShutter)
    (windowBlind)
    (awningTerrace)
    (awningFacade)
    (awningFacadeHorizontal)
    (curtain)
    (internalBlind)
);


/// Example: blinds1
DS_REFLECTED_ENUM((dsModel), ShadeProtectionClass,
    (none)
    (blinds1)
    (blinds2)
    (blinds3)
    (blinds4)
    (blinds5)
    (blinds6)
    (awnings1)
    (awnings2)
    (awnings3)
);

namespace dsModel {
struct OutputAttributes {

  /// Example: Output #1
  std::string name{};
  std::string technicalName{};
  OutputType type{};
  OutputFunction function{};
  std::optional<double> min{};
  std::optional<double> max{};
  std::optional<double> resolution{};
  OutputMode mode{};
  std::optional<double> levels{};
  std::vector<double> levelThresholds{};

  ~OutputAttributes();
};

struct Output {
  OutputId id{};
  OutputAttributes attributes{};

  ~Output();
};

struct OutputStatus {
  OutputId id{};

  /// current output value when device is not moving or dimming
  std::optional<double> value{};

  /// start value when the device is moving or dimming
  std::optional<double> initialValue{};
  OutputStatusStatus status{};

  /// target value when the device is moving or dimming
  std::optional<double> targetValue{};

  /// start time of moving or dimming process
  ds::DateTime startedAt{};

  /// predicted completion time of moving or dimming process
  ds::DateTime terminatesAt{};

  /// active level for output with levels
  std::optional<int> level{};

  ~OutputStatus();
};

struct ButtonAttributes {

  /// Example: Button #1
  std::string name{};
  std::string technicalName{};
  ButtonType type{};
  ButtonMode mode{};
  std::optional<int> channel{};

  ~ButtonAttributes();
};

struct Button {
  ButtonId id{};
  ButtonAttributes attributes{};

  ~Button();
};

struct MeasurementOriginZone {
  std::string type = "zone";
  ZoneId id{};

  ~MeasurementOriginZone();
};

struct MeasurementOriginOutdoor {
  std::string type = "outdoor";

  ~MeasurementOriginOutdoor();
};

struct MeasurementOriginApartment {
  std::string type = "apartment";

  ~MeasurementOriginApartment();
};

struct MeasurementOriginController {
  std::string type = "controller";
  ControllerId id{};

  ~MeasurementOriginController();
};

using MeasurementOrigin = std::variant<std::monostate, MeasurementOriginZone, MeasurementOriginOutdoor, MeasurementOriginApartment, MeasurementOriginController>;

struct MeasurementAttributes {
  MeasurementType type{};
  MeasurementOrigin origin{};

  /// Measured value
  ///
  /// Example: 21.7
  std::optional<double> value{};

  ~MeasurementAttributes();
};

struct Measurement {
  MeasurementId id{};
  std::string type = "measurement";
  ds::DateTime lastChanged{};
  MeasurementAttributes attributes{};

  ~Measurement();
};

struct SensorAttributes {

  /// Example: Sensor #1
  std::string name{};
  std::string technicalName{};
  MeasurementType type{};
  MeasurementUsage usage{};
  std::optional<double> min{};
  std::optional<double> max{};
  std::optional<double> resolution{};

  ~SensorAttributes();
};

struct Sensor {
  SensorId id{};
  SensorAttributes attributes{};

  ~Sensor();
};

struct SensorStatus {
  SensorId id{};
  SensorStatusStatus status{};

  /// last measured value
  std::optional<double> value{};

  ~SensorStatus();
};

struct FunctionBlockAttributes {

  /// User given name
  ///
  /// Example: Dimmer Output #1
  std::string name{};

  /// Example: E-KM200 Dimmer Output
  std::string technicalName{};

  /// Availability status
  ///
  /// Example: True
  std::optional<bool> active{};
  std::vector<Output> outputs{};
  std::vector<Button> buttonInputs{};
  std::vector<Sensor> sensorInputs{};
  SubmoduleId submodule{};
  DeviceAdapterId deviceAdapter{};

  ~FunctionBlockAttributes();
};

struct FunctionBlock {
  FunctionBlockId id{};
  std::string type = "functionBlock";
  ds::DateTime lastChanged{};
  FunctionBlockAttributes attributes{};

  ~FunctionBlock();
};

struct FunctionBlocks {
  std::vector<FunctionBlock> functionBlocks{};

  ~FunctionBlocks();
};

struct FunctionBlockStatus {
  FunctionBlockId id{};
  std::vector<OutputStatus> outputs{};
  std::vector<SensorStatus> sensorInputs{};

  ~FunctionBlockStatus();
};

struct SubmoduleStatus {
  SubmoduleId id{};
  std::optional<bool> operationsLocked{};

  ~SubmoduleStatus();
};

struct SubmoduleAttributes {

  /// User given name
  ///
  /// Example: Upper lamp ring
  std::string name{};

  /// Technical name
  ///
  /// Example: GE-KM200 Dimmer Output
  std::string technicalName{};
  DSDeviceId dsDevice{};
  std::vector<FunctionBlockId> functionBlocks{};
  ZoneId zone{};
  ZoneApplicationType application{};

  ~SubmoduleAttributes();
};

struct Submodule {
  SubmoduleId id{};
  std::string type = "submodule";
  ds::DateTime lastChanged{};
  SubmoduleAttributes attributes{};

  ~Submodule();
};

struct Submodules {
  std::vector<Submodule> submodules{};

  ~Submodules();
};

struct StateOption {
  StateOptionId id{};
  Translatable name{};

  ~StateOption();
};

struct State {
  StateId id{};
  std::vector<StateOption> options{};
  Translatable name{};

  ~State();
};

struct StateStatus {
  StateId id{};
  StateOptionId value{};

  ~StateStatus();
};

struct ShadeAttributes {
  ShadeType shadeType{};
  ShadeProtectionClass protectionClass{};
  IntercardinalDirection mountOrientation{};

  ~ShadeAttributes();
};

struct DSDeviceAttributes {

  /// User given name
  ///
  /// Example: Chandelier
  std::string name{};

  /// Technical name, HWInfo
  ///
  /// Example: Super-Leuchte SL356
  std::string model{};

  /// dS-Device GTIN
  ///
  /// Example: 4290046000607
  std::string gtin{};

  /// DSID in SGTIN96 format
  ///
  /// Example: 302ed89f43f02dc0000b63b8
  std::string dsid{};

  /// Short Id for presentation and UI
  ///
  /// Example: 00016c13
  std::string displayId{};

  /// Currently connected and active or not
  ///
  /// Example: True
  std::optional<bool> present{};

  /// Time of first registration
  ds::DateTime firstSeen{};

  /// Time when inactivity ended
  ds::DateTime lastDiscovered{};

  /// Time when inactivity started
  ds::DateTime inactiveSince{};
  ShadeAttributes shadeAttributes{};
  std::vector<SubmoduleId> submodules{};
  ZoneId zone{};
  std::vector<DeviceScenarioId> scenarios{};
  std::vector<State> states{};

  ~DSDeviceAttributes();
};

struct DSDevice {
  DSDeviceId id{};
  std::string type = "dsDevice";
  ds::DateTime lastChanged{};
  DSDeviceAttributes attributes{};

  ~DSDevice();
};

struct DSDevices {
  std::vector<DSDevice> dsDevices{};

  ~DSDevices();
};

struct DSDeviceStatusAttributes {
  std::vector<FunctionBlockStatus> functionBlocks{};
  std::vector<SubmoduleStatus> submodules{};
  std::vector<StateStatus> states{};

  ~DSDeviceStatusAttributes();
};

struct DSDeviceStatus {
  DSDeviceId id{};
  std::string type = "dsDeviceStatus";
  ds::DateTime lastChanged{};
  DSDeviceStatusAttributes attributes{};

  ~DSDeviceStatus();
};

struct DSDeviceStatuses {
  std::vector<DSDeviceStatus> dsDevices{};

  ~DSDeviceStatuses();
};

} // namespace dsModel

DS_JSON_DECLARE_STRUCT((dsModel), OutputAttributes,
    (name)
    (technicalName)
    (type)
    (function)
    (min)
    (max)
    (resolution)
    (mode)
    (levels)
    (levelThresholds)
);
DS_JSON_DECLARE_STRUCT((dsModel), Output,
    (id)
    (attributes)
);
DS_JSON_DECLARE_STRUCT((dsModel), OutputStatus,
    (id)
    (value)
    (initialValue)
    (status)
    (targetValue)
    (startedAt)
    (terminatesAt)
    (level)
);
DS_JSON_DECLARE_STRUCT((dsModel), ButtonAttributes,
    (name)
    (technicalName)
    (type)
    (mode)
    (channel)
);
DS_JSON_DECLARE_STRUCT((dsModel), Button,
    (id)
    (attributes)
);
DS_JSON_DECLARE_STRUCT((dsModel), MeasurementOriginZone,
    (type)
    (id)
);
DS_JSON_DECLARE_STRUCT((dsModel), MeasurementOriginOutdoor,
    (type)
);
DS_JSON_DECLARE_STRUCT((dsModel), MeasurementOriginApartment,
    (type)
);
DS_JSON_DECLARE_STRUCT((dsModel), MeasurementOriginController,
    (type)
    (id)
);
template <>
struct DSJsonVariantTrait<dsModel::MeasurementOrigin> {
  static constexpr auto discriminator = "type";
  static constexpr auto nameVisitor = ::ds::Visitor{
      [](const std::monostate &) { return ""; },
      [](const dsModel::MeasurementOriginZone &) { return "zone"; },
      [](const dsModel::MeasurementOriginOutdoor &) { return "outdoor"; },
      [](const dsModel::MeasurementOriginApartment &) { return "apartment"; },
      [](const dsModel::MeasurementOriginController &) { return "controller"; },
  };
};
DS_JSON_DECLARE((dsModel), MeasurementOrigin);

DS_JSON_DECLARE_STRUCT((dsModel), MeasurementAttributes,
    (type)
    (origin)
    (value)
);
DS_JSON_DECLARE_STRUCT((dsModel), Measurement,
    (id)
    (type)
    (lastChanged)
    (attributes)
);
DS_JSON_DECLARE_STRUCT((dsModel), SensorAttributes,
    (name)
    (technicalName)
    (type)
    (usage)
    (min)
    (max)
    (resolution)
);
DS_JSON_DECLARE_STRUCT((dsModel), Sensor,
    (id)
    (attributes)
);
DS_JSON_DECLARE_STRUCT((dsModel), SensorStatus,
    (id)
    (status)
    (value)
);
DS_JSON_DECLARE_STRUCT((dsModel), FunctionBlockAttributes,
    (name)
    (technicalName)
    (active)
    (outputs)
    (buttonInputs)
    (sensorInputs)
    (submodule)
    (deviceAdapter)
);
DS_JSON_DECLARE_STRUCT((dsModel), FunctionBlock,
    (id)
    (type)
    (lastChanged)
    (attributes)
);
DS_JSON_DECLARE_STRUCT((dsModel), FunctionBlocks,
    (functionBlocks)
);
DS_JSON_DECLARE_STRUCT((dsModel), FunctionBlockStatus,
    (id)
    (outputs)
    (sensorInputs)
);
DS_JSON_DECLARE_STRUCT((dsModel), SubmoduleStatus,
    (id)
    (operationsLocked)
);
DS_JSON_DECLARE_STRUCT((dsModel), SubmoduleAttributes,
    (name)
    (technicalName)
    (dsDevice)
    (functionBlocks)
    (zone)
    (application)
);
DS_JSON_DECLARE_STRUCT((dsModel), Submodule,
    (id)
    (type)
    (lastChanged)
    (attributes)
);
DS_JSON_DECLARE_STRUCT((dsModel), Submodules,
    (submodules)
);
DS_JSON_DECLARE_STRUCT((dsModel), StateOption,
    (id)
    (name)
);
DS_JSON_DECLARE_STRUCT((dsModel), State,
    (id)
    (options)
    (name)
);
DS_JSON_DECLARE_STRUCT((dsModel), StateStatus,
    (id)
    (value)
);
DS_JSON_DECLARE_STRUCT((dsModel), ShadeAttributes,
    (shadeType)
    (protectionClass)
    (mountOrientation)
);
DS_JSON_DECLARE_STRUCT((dsModel), DSDeviceAttributes,
    (name)
    (model)
    (gtin)
    (dsid)
    (displayId)
    (present)
    (firstSeen)
    (lastDiscovered)
    (inactiveSince)
    (shadeAttributes)
    (submodules)
    (zone)
    (scenarios)
    (states)
);
DS_JSON_DECLARE_STRUCT((dsModel), DSDevice,
    (id)
    (type)
    (lastChanged)
    (attributes)
);
DS_JSON_DECLARE_STRUCT((dsModel), DSDevices,
    (dsDevices)
);
DS_JSON_DECLARE_STRUCT((dsModel), DSDeviceStatusAttributes,
    (functionBlocks)
    (submodules)
    (states)
);
DS_JSON_DECLARE_STRUCT((dsModel), DSDeviceStatus,
    (id)
    (type)
    (lastChanged)
    (attributes)
);
DS_JSON_DECLARE_STRUCT((dsModel), DSDeviceStatuses,
    (dsDevices)
);

