// Generated file.  DO NOT EDIT!
// source: remote-connectivity.yaml

// clang-format off

#pragma once


/// Remote-connectivity
///
/// Remote connectivity associated installation with cloud.

#include "remote-connectivity-fwd.h"
#include <ds/enum.h>
#include <ds/clock.h>

#include "common.h"

#include <ds/json.h>

namespace dsModel {
struct AuthorizeRemoteConnectivityArgs {

  /// Registered partner application id.
  ///
  /// Example: clientId-1
  std::string client_id{};

  ~AuthorizeRemoteConnectivityArgs();
};

struct AuthorizeRemoteConnectivityResult {

  /// Used to poll the token
  ///
  /// Example: hbznP7vAw3EQ7mzJr4kmogqJmhWzbL
  std::string device_code{};

  /// Entered by user for verification
  ///
  /// Example: q7s1oZkQ
  std::string user_code{};

  /// Verification uri that the user needs to open.
  ///
  /// Example: www.example.com/verification
  std::string verification_uri{};

  /// Verification uri with populated user code that the user needs to open
  ///
  /// Example: www.example.com/verification?user_code=q7s1oZkQ
  std::string verification_uri_complete{};

  /// Expiry of authorization session in seconds
  std::optional<double> expires_in{};

  /// Interval to poll the token endpoint in seconds
  std::optional<double> interval{};

  ~AuthorizeRemoteConnectivityResult();
};

struct PollAuthorizationRemoteConnectivityArgs {

  /// Device code returned by `authorize` endpoint
  ///
  /// Example: hbznP7vAw3EQ7mzJr4kmogqJmhWzbL
  std::string device_code{};

  /// Client id passed to the `authorize` endpoint
  ///
  /// Example: clientId-1
  std::string client_id{};

  ~PollAuthorizationRemoteConnectivityArgs();
};

struct RemoteConnectivityAttributes {

  /// Is the remote connectivity authorized
  std::optional<bool> authorized{};

  /// Is the remote connectivity connected now?
  std::optional<bool> connected{};

  /// Email
  ///
  /// Example: user@example.com
  std::string email{};

  /// Relay (aka pagekite) name
  ///
  /// Example: relay-name
  std::string relayName{};

  /// Relay (aka pagekite) url
  ///
  /// Example: relay-name.digitalstrom.net
  std::string relayUrl{};

  ~RemoteConnectivityAttributes();
};

struct RemoteConnectivity {
  RemoteConnectivityId id{};
  std::string type = "remoteConnectivity";
  ds::DateTime lastChanged{};
  RemoteConnectivityAttributes attributes{};

  ~RemoteConnectivity();
};

} // namespace dsModel

DS_JSON_DECLARE_STRUCT((dsModel), AuthorizeRemoteConnectivityArgs,
    (client_id)
);
DS_JSON_DECLARE_STRUCT((dsModel), AuthorizeRemoteConnectivityResult,
    (device_code)
    (user_code)
    (verification_uri)
    (verification_uri_complete)
    (expires_in)
    (interval)
);
DS_JSON_DECLARE_STRUCT((dsModel), PollAuthorizationRemoteConnectivityArgs,
    (device_code)
    (client_id)
);
DS_JSON_DECLARE_STRUCT((dsModel), RemoteConnectivityAttributes,
    (authorized)
    (connected)
    (email)
    (relayName)
    (relayUrl)
);
DS_JSON_DECLARE_STRUCT((dsModel), RemoteConnectivity,
    (id)
    (type)
    (lastChanged)
    (attributes)
);

