#include <ds/catch/catch.h>
#include <ds/log.h>
#include <ds485types.h>

using namespace std::literals;
static ds::LogChannel dsLogChannel("ds485typesTest");
static const char* TAGS = "[dss][ds485types]";

using namespace dss;

namespace {

SCENARIO("convert dsid/dsuid", TAGS) {
  SECTION("dsuid") {
    const auto id = "1111111111111111111111111111111100"s;
    auto dsuid = str2dsuid(id);
    CHECK(ds::str(dsuid) == id);
  }

  SECTION("dsid") {
    const auto id = "111111111111111111111112"s;
    auto dsid = str2dsid(id.c_str());
    CHECK(ds::str(dsid) == id);
  }
}

SCENARIO("dsuid operators", TAGS) {
  SECTION("operator<") {
    const auto id = Dsuid{"1111111111111111111111111111111100"s};
    const auto id2 = Dsuid{"1111111111111111111111111111111101"s};

    CHECK(id < id2);
    CHECK(!(id2 < id));
    CHECK(!(id < id));
  }
}

} // namespace
