/*
    Copyright (c) 2022 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

*/

#pragma once

#include <ds/json.h>

#include "metering/archives.h"
#include "metering/config.h"

namespace dss::metering {

struct P1Reading {
  std::string meterId;
  ds::DateTime timestamp;
  double powerConsumed;
  double powerProduced;
  double t1EnergyConsumed;
  double t1EnergyProduced;
  double t2EnergyConsumed;
  double t2EnergyProduced;
};

class OpenMeteringSystem {
public:
  virtual ~OpenMeteringSystem() = default;

#if 0
  virtual ValueRange getSeries(std::vector<Dsuid> meterIds, std::chrono::seconds resolution, SeriesTypes _type,
                               bool _energyInWh, const TimeDuration& timeDuration, int _valueCount) const = 0;
  // virtual double get15MinuteAverage(std::vector<Dsuid> meterIds, metering::SeriesTypes type, Unit unit) const = 0;

  virtual std::optional<ArchiveValue> getEnergy(const dsuid_t& meterId) const = 0;

  virtual bool has() const = 0;

  virtual double getInstantPower(const dsuid_t& meterId) const = 0;
  virtual unsigned int getApartmentPower() const = 0;

#endif
  virtual void addReading(metering::P1Reading&& p1Reading) = 0;
};

std::unique_ptr<OpenMeteringSystem> makeOpenMeteringSystem(Archives& archives, ElectricityMeteringConfig&);

} // namespace dss::metering

DS_JSON_DECLARE_STRUCT((dss::metering), P1Reading,
                       (meterId)(timestamp)(powerConsumed)(powerProduced)(t1EnergyConsumed)(t1EnergyProduced)(
                           t2EnergyConsumed)(t2EnergyProduced));
