#pragma once

#include <metering/metering.h>
#include <metering/power-states-fwd.h>
#include <model/apartment.h>

namespace dss::metering {

class PowerStates {
public:
  virtual ~PowerStates() = default;
  virtual std::shared_ptr<State> createState(MeteringSystem meteringSystem, PowerStateConfig&& powerStateConfig) = 0;
  virtual void removeState(MeteringSystem meteringSystem, const PowerStateConfig& powerStateConfig) = 0;
  virtual void trigger(MeteringSystem meteringSystem, TotalPower&& totalPower) = 0;
};

std::shared_ptr<PowerStates> makePowerStates(Apartment& apartment);

} // namespace dss::metering
