/*
    Copyright (c) 2021 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

*/

#pragma once

#include <ds/reflect.h>

#include <memory>

#include "ds-model/devices-fwd.h"
#include "model/device.h"

namespace dss::model {

std::optional<dsModel::ShadeType> tryDefaultShadeType(const Device& device);
dsModel::ShadeType defaultShadeType(const Device& device);

struct ShadeManipulator {
  virtual ~ShadeManipulator() = default;
  virtual dsModel::ShadeType shadeType(const Device& device) = 0;
  virtual void setShadeType(Device& device, dsModel::ShadeType shadeType) = 0;
};

std::unique_ptr<ShadeManipulator> makeShadeManipulator(Apartment& apartment, DeviceBusInterface& deviceBusInterface);

} // namespace dss::model
