#pragma once

#include <ds/json.h>

#include <string>
#include <vector>

#include "metering/open-metering-system.h"

namespace dss::p1 {

using MeterReading = dss::metering::P1Reading;

class MeterParser {
public:
  std::optional<MeterReading> parseFrame(const std::vector<char>& buffer);
  bool vaildateCrc(const std::vector<char>& buffer, std::string crc);
  int getCrcErrorCount() { return m_crcErrCount; }
  void resetCrcCount() { m_crcErrCount = 0; }

private:
  ds::DateTime getTimeStamp(std::string p1TimeStamp);
  void parseLine(const std::string& line, dss::p1::MeterReading& currentReading);

  int m_crcErrCount = 0;
};

} // namespace dss::p1
