#pragma once

#include <ds/enum.h>
#include <string>

namespace dss {

class JSONWriter;
class Device;
class StructureManipulator;
class Apartment;

namespace view {
namespace umr200Config {

void get(JSONWriter& json, const Device& device);
void setValue(Device& device, StructureManipulator& manipulator, const std::string& json, JSONWriter& updatedDevices, const Apartment&);

} // namespace umr200Config

inline void getConfig(JSONWriter& json, const Device& device) { umr200Config::get(json, device); }
inline void applyConfigValue(Device& device, StructureManipulator& manipulator, const std::string& json, JSONWriter& updatedDevices, const Apartment& apartment) {
  umr200Config::setValue(device, manipulator, json, updatedDevices, apartment);
}

} // namespace view
} // namespace dss
